/*	
 *	clipfram.c
 *
 *	RAMɓ]郂W[
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2002 Naoyuki Sawa
 *
 *	* Tue Nov 19 12:30:00 JST 2002 Naoyuki Sawa
 *	- clipdobj.cclipmod.cARs[ECĐVK쐬܂B
 *	* Sun Dec 8 05:43:00 JST 2002 Naoyuki Sawa
 *	- mod_mix()̃[voOCB
 *	- e|GtFNgΉB
 */
#include "clip.h"

/****************************************************************************
 *	pceLCDDrawObject
 ****************************************************************************/

/* * pceLCDDrawObjectɂ́Â悤Ȑ܂B
 * - ]@DRW_NOMALAA]rbg}bv2bitf[^masktłꍇȊÓA
 *   {pceLCDDrawObjectɏC܂BĂяo镪AxȂ܂B
 * - ]`ɁA]rbg}bv͂ݏöw肷ƁA삵܂B
 * - ]rbg}bv́A8sNZPʂ̃TCYō쐬ĂȂ΂܂B
 *   ̐́AP/ECErbg}bv`̐ł̂ŁAɒӂKv͂܂B
 * * AvP[VNɈxhook_LCDDrawObject()ĂсA
 *   AvP[VIɂ͕Kunhook_LCDDrawObject()ǂłB
 */

extern int (*old_LCDDrawObject)(DRAW_OBJECT);	/* {pceLCDDrawObjectۑ -> clippce.c */

int
new_LCDDrawObject(DRAW_OBJECT obj)
{
	PIECE_VRAM dest;
	PIECE_BMP src;
	int n, x, y, step, dest_stride, src_stride;
	unsigned char *dest_buf, *src_mask, mask;
	unsigned short *src_buf, pixel;

	/* ]rbg}bvoĂ܂B
	 * 2bitf[^܂2bitf[^masktłȂ΁A{ɔC܂B
	 */
	src = *obj.src;
	if(src.header.bpp == 2) {
		/* ]VRAM擾B */
		if(obj.dest != NULL) {
			dest = *obj.dest;
		} else {
			dest.w = DISP_X;
			dest.h = DISP_Y;
			dest.buf = pceLCDSetBuffer(INVALIDPTR);
		}

		/* ]NbsOB */
		if(!(obj.param & DRW_REVX)) {
			if(obj.dx < obj.clip.left) {
				n = obj.clip.left - obj.dx; /* ɂ͂ݏosNZ */
				obj.dx = obj.clip.left;
				obj.dw -= n;
				obj.sx += n;
			}
			if(obj.dx + obj.dw > obj.clip.right) {
				obj.dw = obj.clip.right - obj.dx;
			}
			if(obj.dw <= 0) return 0; /* ʊO */
		} else {
			if(obj.dx < obj.clip.left) {
				n = obj.clip.left - obj.dx; /* ɂ͂ݏosNZ */
				obj.dx = obj.clip.left;
				obj.dw -= n;
			}
			if(obj.dx + obj.dw > obj.clip.right) {
				n = obj.dx + obj.dw - obj.clip.right; /* Eɂ͂ݏosNZ */
				obj.dw -= n;
				obj.sx += n;
			}
			if(obj.dw <= 0) return 0; /* ʊO */
		}
		if(!(obj.param & DRW_REVY)) {
			if(obj.dy < obj.clip.top) {
				n = obj.clip.top - obj.dy; /* ɂ͂ݏosNZ */
				obj.dy = obj.clip.top;
				obj.dh -= n;
				obj.sy += n;
			}
			if(obj.dy + obj.dh > obj.clip.bottom) {
				obj.dh = obj.clip.bottom - obj.dy;
			}
			if(obj.dh <= 0) return 0; /* ʊO */
		} else {
			if(obj.dy < obj.clip.top) {
				n = obj.clip.top - obj.dy; /* ɂ͂ݏosNZ */
				obj.dy = obj.clip.top;
				obj.dh -= n;
			}
			if(obj.dy + obj.dh > obj.clip.bottom) {
				n = obj.dy + obj.dh - obj.clip.bottom; /* ɂ͂ݏosNZ */
				obj.dh -= n;
				obj.sy += n;
			}
			if(obj.dh <= 0) return 0; /* ʊO */
		}

		/* ]NbsO͍s܂B
		 * Xw肳ꂽ]`]rbg}bvɎ܂ĂȂ΁A
		 * ]NbsOɂē]͂ݏoƂ͂肦ȂłB
		 * {͓]NbsOsĂ̂ŁA̓_͔݊łB
		 */

		/* ]sNZAhX߂܂B */
		n = (src.header.w * obj.sy + obj.sx) / 8;
		src_buf = (unsigned short*)src.buf + n;
		src_mask = src.mask + n;
		src_stride = src.header.w / 8 - ((obj.sx & 7) + obj.dw - 1) / 8;
		/*                                                     ~~~      */
		/* 8Xebvɐiނ̂ł͂ȂA9Xebvڂ̐擪Őiނ */

		/* ]ɂāA𕪂܂B(DRW_NOMAL=0Ɖ)
		 * ]ȊÕtOw肳ĂA{ɔC܂B
		 */
		switch(obj.param) {
		case 0/*]Ȃ*/:
			/* ]sNZAhX߂܂B */
			dest_buf = dest.buf + dest.w * obj.dy + obj.dx;
			dest_stride = dest.w - obj.dw;

			y = obj.dh; /* c胉C */
			switch(src.header.mask) {
			case 0/*2bitf[^*/:
				do {
					/* 8sNZPʂ̂AsNZڂJn邩H */
					step = obj.sx & 7;

					/* Jn_n܂邩rn܂邩킩Ȃ̂ŁA
					 * ͂Ƃstep=0łAōŏ̃f[^擾邱Ƃɂ܂B
					 * P/ECErbg}bṽsNZт́AMSB̃sNZȂłˁB
					 *   S1C33̓gGfBAȂ񂾂ALSB̃sNZɂ₷Ǝv̂łB
					 *   WindowsBMPMSB̃sNZȂ̂ȁHȂ΁ABMP̎dlɍ킹̂m܂B
					 */
					pixel = *src_buf;	/* sNZт MSB:45670123:LSB ̏ł */

					/* sNZڂJn邩ɂāAK؂Ȉʒu֔э݂܂B */
					x = obj.dw; /* csNZ */
					switch(step) {
LOOP_01: /* ͔͂щz܂ */
						/* 8sNZPʂ̊Jn_ŁÃf[^擾܂B */
						pixel = *++src_buf;
#define PIXEL(p) \
						/* sNZA`܂B */ \
						*dest_buf++ = pixel >> (p) * 2 & 3; \
						/* 1C]A܂B */ \
						if(--x == 0) break;
					case 0: PIXEL(3);
					case 1: PIXEL(2);
					case 2: PIXEL(1);
					case 3: PIXEL(0);
					case 4: PIXEL(7);
					case 5: PIXEL(6);
					case 6: PIXEL(5);
					default/*7*/: PIXEL(4); goto LOOP_01;
#undef PIXEL
					}

					/* ]E]sNZAhX̃C֐i߂܂B */
					dest_buf += dest_stride;
					src_buf += src_stride;
				} while(--y != 0);
				return 1; /* `抮 */

			case 1/*2bitf[^maskt*/:
				do {
					/* 8sNZPʂ̂AsNZڂJn邩H */
					step = obj.sx & 7;

					/* Jn_n܂邩rn܂邩킩Ȃ̂ŁA
					 * ͂Ƃstep=0łAōŏ̃f[^擾邱Ƃɂ܂B
					 * P/ECErbg}bṽsNZт́AMSB̃sNZȂłˁB
					 *   S1C33̓gGfBAȂ񂾂ALSB̃sNZɂ₷Ǝv̂łB
					 *   WindowsBMPMSB̃sNZȂ̂ȁHȂ΁ABMP̎dlɍ킹̂m܂B
					 */
					pixel = *src_buf;	/* sNZт MSB:45670123:LSB ̏ł */
					mask = *src_mask;	/* sNZт MSB:01234567:LSB ̏ł */

					/* sNZڂJn邩ɂāAK؂Ȉʒu֔э݂܂B */
					x = obj.dw; /* csNZ */
					switch(step) {
LOOP_02: /* ͔͂щz܂ */
						/* 8sNZPʂ̊Jn_ŁÃf[^擾܂B */
						pixel = *++src_buf;
						mask = *++src_mask;
#define PIXEL(p, m) \
						/* ssNZȂA`܂B */ \
						if(mask >> (m) & 1) *dest_buf = pixel >> (p) * 2 & 3; \
						dest_buf++; \
						/* 1C]A܂B */ \
						if(--x == 0) break;
					case 0: PIXEL(3, 7);
					case 1: PIXEL(2, 6);
					case 2: PIXEL(1, 5);
					case 3: PIXEL(0, 4);
					case 4: PIXEL(7, 3);
					case 5: PIXEL(6, 2);
					case 6: PIXEL(5, 1);
					default/*7*/: PIXEL(4, 0); goto LOOP_02;
#undef PIXEL
					}

					/* ]E]sNZAhX̃C֐i߂܂B */
					dest_buf += dest_stride;
					src_buf += src_stride;
					src_mask += src_stride;
				} while(--y != 0);
				return 1; /* `抮 */
			}
			break; /* {ɔC܂ */

		case DRW_REVX:
			/* ]sNZAhX߂܂B */
			dest_buf = dest.buf + dest.w * obj.dy + obj.dx + obj.dw - 1;
			dest_stride = dest.w + obj.dw;

			y = obj.dh; /* c胉C */
			switch(src.header.mask) {
			case 0/*2bitf[^*/:
				do {
					/* 8sNZPʂ̂AsNZڂJn邩H */
					step = obj.sx & 7;

					/* Jn_n܂邩rn܂邩킩Ȃ̂ŁA
					 * ͂Ƃstep=0łAōŏ̃f[^擾邱Ƃɂ܂B
					 * P/ECErbg}bṽsNZт́AMSB̃sNZȂłˁB
					 *   S1C33̓gGfBAȂ񂾂ALSB̃sNZɂ₷Ǝv̂łB
					 *   WindowsBMPMSB̃sNZȂ̂ȁHȂ΁ABMP̎dlɍ킹̂m܂B
					 */
					pixel = *src_buf;	/* sNZт MSB:45670123:LSB ̏ł */

					/* sNZڂJn邩ɂāAK؂Ȉʒu֔э݂܂B */
					x = obj.dw; /* csNZ */
					switch(step) {
LOOP_11: /* ͔͂щz܂ */
						/* 8sNZPʂ̊Jn_ŁÃf[^擾܂B */
						pixel = *++src_buf;
#define PIXEL(p) \
						/* sNZA`܂B */ \
						*dest_buf-- = pixel >> (p) * 2 & 3; \
						/* 1C]A܂B */ \
						if(--x == 0) break;
					case 0: PIXEL(3);
					case 1: PIXEL(2);
					case 2: PIXEL(1);
					case 3: PIXEL(0);
					case 4: PIXEL(7);
					case 5: PIXEL(6);
					case 6: PIXEL(5);
					default/*7*/: PIXEL(4); goto LOOP_11;
#undef PIXEL
					}

					/* ]E]sNZAhX̃C֐i߂܂B */
					dest_buf += dest_stride;
					src_buf += src_stride;
				} while(--y != 0);
				return 1; /* `抮 */

			case 1/*2bitf[^maskt*/:
				do {
					/* 8sNZPʂ̂AsNZڂJn邩H */
					step = obj.sx & 7;

					/* Jn_n܂邩rn܂邩킩Ȃ̂ŁA
					 * ͂Ƃstep=0łAōŏ̃f[^擾邱Ƃɂ܂B
					 * P/ECErbg}bṽsNZт́AMSB̃sNZȂłˁB
					 *   S1C33̓gGfBAȂ񂾂ALSB̃sNZɂ₷Ǝv̂łB
					 *   WindowsBMPMSB̃sNZȂ̂ȁHȂ΁ABMP̎dlɍ킹̂m܂B
					 */
					pixel = *src_buf;	/* sNZт MSB:45670123:LSB ̏ł */
					mask = *src_mask;	/* sNZт MSB:01234567:LSB ̏ł */

					/* sNZڂJn邩ɂāAK؂Ȉʒu֔э݂܂B */
					x = obj.dw; /* csNZ */
					switch(step) {
LOOP_12: /* ͔͂щz܂ */
						/* 8sNZPʂ̊Jn_ŁÃf[^擾܂B */
						pixel = *++src_buf;
						mask = *++src_mask;
#define PIXEL(p, m) \
						/* ssNZȂA`܂B */ \
						if(mask >> (m) & 1) *dest_buf = pixel >> (p) * 2 & 3; \
						dest_buf--; \
						/* 1C]A܂B */ \
						if(--x == 0) break;
					case 0: PIXEL(3, 7);
					case 1: PIXEL(2, 6);
					case 2: PIXEL(1, 5);
					case 3: PIXEL(0, 4);
					case 4: PIXEL(7, 3);
					case 5: PIXEL(6, 2);
					case 6: PIXEL(5, 1);
					default/*7*/: PIXEL(4, 0); goto LOOP_12;
#undef PIXEL
					}

					/* ]E]sNZAhX̃C֐i߂܂B */
					dest_buf += dest_stride;
					src_buf += src_stride;
					src_mask += src_stride;
				} while(--y != 0);
				return 1; /* `抮 */
			}
			break; /* {ɔC܂ */

		case DRW_REVY:
			/* ]sNZAhX߂܂B */
			dest_buf = dest.buf + dest.w * (obj.dy + obj.dh - 1) + obj.dx;
			dest_stride = -dest.w - obj.dw;

			y = obj.dh; /* c胉C */
			switch(src.header.mask) {
			case 0/*2bitf[^*/:
				do {
					/* 8sNZPʂ̂AsNZڂJn邩H */
					step = obj.sx & 7;

					/* Jn_n܂邩rn܂邩킩Ȃ̂ŁA
					 * ͂Ƃstep=0łAōŏ̃f[^擾邱Ƃɂ܂B
					 * P/ECErbg}bṽsNZт́AMSB̃sNZȂłˁB
					 *   S1C33̓gGfBAȂ񂾂ALSB̃sNZɂ₷Ǝv̂łB
					 *   WindowsBMPMSB̃sNZȂ̂ȁHȂ΁ABMP̎dlɍ킹̂m܂B
					 */
					pixel = *src_buf;	/* sNZт MSB:45670123:LSB ̏ł */

					/* sNZڂJn邩ɂāAK؂Ȉʒu֔э݂܂B */
					x = obj.dw; /* csNZ */
					switch(step) {
LOOP_21: /* ͔͂щz܂ */
						/* 8sNZPʂ̊Jn_ŁÃf[^擾܂B */
						pixel = *++src_buf;
#define PIXEL(p) \
						/* sNZA`܂B */ \
						*dest_buf++ = pixel >> (p) * 2 & 3; \
						/* 1C]A܂B */ \
						if(--x == 0) break;
					case 0: PIXEL(3);
					case 1: PIXEL(2);
					case 2: PIXEL(1);
					case 3: PIXEL(0);
					case 4: PIXEL(7);
					case 5: PIXEL(6);
					case 6: PIXEL(5);
					default/*7*/: PIXEL(4); goto LOOP_21;
#undef PIXEL
					}

					/* ]E]sNZAhX̃C֐i߂܂B */
					dest_buf += dest_stride;
					src_buf += src_stride;
				} while(--y != 0);
				return 1; /* `抮 */

			case 1/*2bitf[^maskt*/:
				do {
					/* 8sNZPʂ̂AsNZڂJn邩H */
					step = obj.sx & 7;

					/* Jn_n܂邩rn܂邩킩Ȃ̂ŁA
					 * ͂Ƃstep=0łAōŏ̃f[^擾邱Ƃɂ܂B
					 * P/ECErbg}bṽsNZт́AMSB̃sNZȂłˁB
					 *   S1C33̓gGfBAȂ񂾂ALSB̃sNZɂ₷Ǝv̂łB
					 *   WindowsBMPMSB̃sNZȂ̂ȁHȂ΁ABMP̎dlɍ킹̂m܂B
					 */
					pixel = *src_buf;	/* sNZт MSB:45670123:LSB ̏ł */
					mask = *src_mask;	/* sNZт MSB:01234567:LSB ̏ł */

					/* sNZڂJn邩ɂāAK؂Ȉʒu֔э݂܂B */
					x = obj.dw; /* csNZ */
					switch(step) {
LOOP_22: /* ͔͂щz܂ */
						/* 8sNZPʂ̊Jn_ŁÃf[^擾܂B */
						pixel = *++src_buf;
						mask = *++src_mask;
#define PIXEL(p, m) \
						/* ssNZȂA`܂B */ \
						if(mask >> (m) & 1) *dest_buf = pixel >> (p) * 2 & 3; \
						dest_buf++; \
						/* 1C]A܂B */ \
						if(--x == 0) break;
					case 0: PIXEL(3, 7);
					case 1: PIXEL(2, 6);
					case 2: PIXEL(1, 5);
					case 3: PIXEL(0, 4);
					case 4: PIXEL(7, 3);
					case 5: PIXEL(6, 2);
					case 6: PIXEL(5, 1);
					default/*7*/: PIXEL(4, 0); goto LOOP_22;
#undef PIXEL
					}

					/* ]E]sNZAhX̃C֐i߂܂B */
					dest_buf += dest_stride;
					src_buf += src_stride;
					src_mask += src_stride;
				} while(--y != 0);
				return 1; /* `抮 */
			}
			break; /* {ɔC܂ */

		case DRW_REVX | DRW_REVY:
			/* ]sNZAhX߂܂B */
			dest_buf = dest.buf + dest.w * (obj.dy + obj.dh - 1) + obj.dx + obj.dw - 1;
			dest_stride = -dest.w + obj.dw;

			y = obj.dh; /* c胉C */
			switch(src.header.mask) {
			case 0/*2bitf[^*/:
				do {
					/* 8sNZPʂ̂AsNZڂJn邩H */
					step = obj.sx & 7;

					/* Jn_n܂邩rn܂邩킩Ȃ̂ŁA
					 * ͂Ƃstep=0łAōŏ̃f[^擾邱Ƃɂ܂B
					 * P/ECErbg}bṽsNZт́AMSB̃sNZȂłˁB
					 *   S1C33̓gGfBAȂ񂾂ALSB̃sNZɂ₷Ǝv̂łB
					 *   WindowsBMPMSB̃sNZȂ̂ȁHȂ΁ABMP̎dlɍ킹̂m܂B
					 */
					pixel = *src_buf;	/* sNZт MSB:45670123:LSB ̏ł */

					/* sNZڂJn邩ɂāAK؂Ȉʒu֔э݂܂B */
					x = obj.dw; /* csNZ */
					switch(step) {
LOOP_31: /* ͔͂щz܂ */
						/* 8sNZPʂ̊Jn_ŁÃf[^擾܂B */
						pixel = *++src_buf;
#define PIXEL(p) \
						/* sNZA`܂B */ \
						*dest_buf-- = pixel >> (p) * 2 & 3; \
						/* 1C]A܂B */ \
						if(--x == 0) break;
					case 0: PIXEL(3);
					case 1: PIXEL(2);
					case 2: PIXEL(1);
					case 3: PIXEL(0);
					case 4: PIXEL(7);
					case 5: PIXEL(6);
					case 6: PIXEL(5);
					default/*7*/: PIXEL(4); goto LOOP_31;
#undef PIXEL
					}

					/* ]E]sNZAhX̃C֐i߂܂B */
					dest_buf += dest_stride;
					src_buf += src_stride;
				} while(--y != 0);
				return 1; /* `抮 */

			case 1/*2bitf[^maskt*/:
				do {
					/* 8sNZPʂ̂AsNZڂJn邩H */
					step = obj.sx & 7;

					/* Jn_n܂邩rn܂邩킩Ȃ̂ŁA
					 * ͂Ƃstep=0łAōŏ̃f[^擾邱Ƃɂ܂B
					 * P/ECErbg}bṽsNZт́AMSB̃sNZȂłˁB
					 *   S1C33̓gGfBAȂ񂾂ALSB̃sNZɂ₷Ǝv̂łB
					 *   WindowsBMPMSB̃sNZȂ̂ȁHȂ΁ABMP̎dlɍ킹̂m܂B
					 */
					pixel = *src_buf;	/* sNZт MSB:45670123:LSB ̏ł */
					mask = *src_mask;	/* sNZт MSB:01234567:LSB ̏ł */

					/* sNZڂJn邩ɂāAK؂Ȉʒu֔э݂܂B */
					x = obj.dw; /* csNZ */
					switch(step) {
LOOP_32: /* ͔͂щz܂ */
						/* 8sNZPʂ̊Jn_ŁÃf[^擾܂B */
						pixel = *++src_buf;
						mask = *++src_mask;
#define PIXEL(p, m) \
						/* ssNZȂA`܂B */ \
						if(mask >> (m) & 1) *dest_buf = pixel >> (p) * 2 & 3; \
						dest_buf--; \
						/* 1C]A܂B */ \
						if(--x == 0) break;
					case 0: PIXEL(3, 7);
					case 1: PIXEL(2, 6);
					case 2: PIXEL(1, 5);
					case 3: PIXEL(0, 4);
					case 4: PIXEL(7, 3);
					case 5: PIXEL(6, 2);
					case 6: PIXEL(5, 1);
					default/*7*/: PIXEL(4, 0); goto LOOP_32;
#undef PIXEL
					}

					/* ]E]sNZAhX̃C֐i߂܂B */
					dest_buf += dest_stride;
					src_buf += src_stride;
					src_mask += src_stride;
				} while(--y != 0);
				return 1; /* `抮 */
			}
			break; /* {ɔC܂ */
		}
	}

	/* [`ΉĂȂ`ȂA{ɔC܂B */
	return old_LCDDrawObject(obj);
}

/****************************************************************************
 *	[eBeBFtHg
 ****************************************************************************/

/* VvCuput_1char()֐(\usr\PIECE\lib\src\simple\symbol.c)Qlɂ܂B
 * ܂ApceFontPut()֐(\usr\PIECE\sysdev\pcekn\font.c)ɕāAr[|[g/Oɂꍇs܂B
 * tHg`̈悪SɃr[|[gȂANbsOȗA{xɕ`ł܂B
 */
unsigned short
render_font(RENDER* render, int x, int y, unsigned short code, int type, int color)
{
	SURFACE* surface;
	unsigned char* vptr;
	const unsigned char* p;
	int ofs, w, h, x_min, y_min, x_max, y_max, c;

	/* tHgTCY߂܂B */
	type &= 0x7f; /* bit7(sw)͖ */
	if(type < 0 || 2 < type) DIE(); /* ȃtHg^Cv */
	w = render_font_size[type][0];
	h = render_font_size[type][1];

	 /* p󔒂͕pɂɎw肳Ǝv̂ŁA`ȗč܂B
	  * w,h͖߂lɎĝŁAw,h擾OɃXLbvȂ悤ӁI
	  */
	if(code == ' ') goto SKIP;

	/* tHgAhX߂܂B */
	pceFontSetType(type);
	p = pceFontGetAdrs(code);

	/* ptHg`c */
	if((int)p & (1 << 31)) {
		p = (unsigned char*)((int)p & ~(1 << 31)); /* prbg낷 */
		/* `͈͂߂܂B */
		x_min = x;
		y_min = y;
		x_max = x + w;
		y_max = y + h;
		/* SɃr[|[gȂANbsOsvłB */
		if(render->left <= x_min && x_max <= render->right &&
		   render->top  <= y_min && y_max <= render->bottom) {
			surface = render->surface;
			ofs = surface->w * y + x;
			vptr = surface->vbuff + ofs;
			for(y = y_min; y < y_max; y++) {
				c = *p++;
				for(x = x_min; x < x_max; x++) {
					if(c & 0x80) *vptr = color;
					vptr++;
					c <<= 1;
				}
				vptr += surface->w - w; /* ̍s */
			}
		/* r[|[g͂ݏoĂAvNbsOB */
		} else {
			for(y = y_min; y < y_max; y++) {
				c = *p++;
				for(x = x_min; x < x_max; x++) {
					if(c & 0x80) render_point(render, x, y, color);
					c <<= 1;
				}
			}
		}
	/* SptHg`c */
	} else {
		w *= 2; /* SpȂ̂œ񕶎̕B߂lɎĝwύXKv */
		/* `͈͂߂܂B */
		x_min = x;
		y_min = y;
		x_max = x + w;
		y_max = y + h;
		/* SɃr[|[gȂANbsOsvłB */
		if(render->left <= x_min && x_max <= render->right &&
		   render->top  <= y_min && y_max <= render->bottom) {
			surface = render->surface;
			ofs = surface->w * y + x;
			vptr = surface->vbuff + ofs;
			for(y = y_min; y < y_max; y += 2) { /* 2CÂ` */
				c = p[0] << 16 | p[1] << 8 | p[2]; /* 3oCg2C */
				p += 3;
				for(x = x_min; x < x_max; x++) {
					if(c & 0x800000) *(vptr + 0         ) = color;
					if(c &    0x800) *(vptr + surface->w) = color;
					vptr++;
					c <<= 1;
				}
				vptr += surface->w * 2 - w; /* s */
			}
		/* r[|[g͂ݏoĂAvNbsOB */
		} else {
			for(y = y_min; y < y_max; y += 2) { /* 2CÂ` */
				c = p[0] << 16 | p[1] << 8 | p[2]; /* 3oCg2C */
				p += 3;
				for(x = x_min; x < x_max; x++) {
					if(c & 0x800000) render_point(render, x, y + 0, color);
					if(c &    0x800) render_point(render, x, y + 1, color);
					c <<= 1;
				}
			}
		}
	}
SKIP:
	return h << 8 | w;
}

/****************************************************************************
 *	P/ECE MOD Driver
 ****************************************************************************/

int
mod_seq(MODDRIVER* driver)
{
	MODHEADER* header = driver->header;
	int chno, *pnote, note, smpno, period, effect;
	MODSAMPLE* sample;
	MODROW* row;
	MODCHANNEL* channel;

	/* `bNi߂܂B */
	driver->tick += driver->tempo;
	if(driver->tick >= driver->speed * 125) {
		driver->tick -= driver->speed * 125;

		/* [擾܂B
		 * * [V[PXԍ́AGtFNgɂĕύX\̂ŁA
		 *   [V[PXԍւ̌JグÍA[擾Oɍs܂B
		 */
		if(driver->rowno >= 64) {
			driver->rowno = 0;
			driver->seqno++;
		}
		if(driver->seqno >= header->seqlen) {
			if(header->seqrep < 127) { /* CR[127̏ꍇtIłI */
				driver->seqno = header->seqrep;
			} else {
				return 1; /* V[PXI */
			}
		}
		row = &driver->pattern[header->sequence[driver->seqno]]->row[driver->rowno];
		driver->rowno++; /* ̂߂Ƀ[i߂Ă܂ */

		/* e`l̃m[g܂B */
		for(chno = 0, channel = driver->channel, pnote = row->note; chno < 4; chno++, channel++, pnote++) {
			note = SWAPW(*pnote);

			/* TvԍύX܂B */
			smpno = (note >> 24 & 0xf0) | (note >> 12 & 0xf);
			if(smpno) {
				smpno--; /* m[g̃Tvԍ#1x[XȂ̂ŁA#0x[Xɕ␳ */
				sample = &header->sample[smpno];
				channel->smpno = smpno;
				channel->volume = sample->volume;
			}

			/* sIhlύX܂B */
			period = note >> 16 & 0xfff;
			if(period) {
				channel->period = period; /* Jn */
				channel->offset = 0;
			}

			/* GtFNgi[܂B */
			effect = note & 0xfff;
			channel->effect = effect;
		}
	}

	/* e`l̃GtFNg܂B */
	for(chno = 0, channel = driver->channel; chno < 4; chno++, channel++) {
		effect = channel->effect;
		if(effect) {
			switch(effect & 0xf00) {
			/*---------- ɊւGtFNg ----------*/
			case 0x100: /* Slide Up */
				channel->period -= effect & 0xff;
				if(channel->period < 0) channel->period = 0;
				/* GtFNgp */
				break;
			case 0x200: /* Slide Down */
				channel->period += effect & 0xff;
				if(channel->period > 0xfff) channel->period = 0xfff;
				/* GtFNgp */
				break;
			/*---------- ʂɊւGtFNg ----------*/
			case 0x500: /* Tone Portamento + Volume Slide */
			case 0x600: /* Vibrato + Volume Slide */
			case 0xa00: /* Volume Slide */
				/* g[|^gEru[g͖ΉłB */
				if(effect & 0xf) {
					channel->volume -= effect & 0xf;
					if(channel->volume < 0) channel->volume = 0;
				} else {
					channel->volume += effect >> 4 & 0xf;
					if(channel->volume > 64) channel->volume = 64;
				}
				/* GtFNgp */
				break;
			case 0xc00: /* Set Volume */
				channel->volume = effect & 0xff;
				channel->effect = 0; /* GtFNg */
				break;
			/*---------- tʒuɊւGtFNg ----------*/
			case 0x900: /* Set Sample Offset */
				channel->offset = (effect & 0xff) << (8/*MODdl*/ + 8/*Œ菬*/);
				channel->effect = 0; /* GtFNg */
				break;
			case 0xb00: /* Position Jump */
				driver->seqno = effect & 0xff;
				driver->rowno = 0;
				channel->effect = 0; /* GtFNg */
				break;
			case 0xd00: /* Pattern Break */
				driver->seqno++;
				driver->rowno = effect & 0xff;
				channel->effect = 0; /* GtFNg */
				break;
			case 0xf00: /* Set Speed */
				if((effect & 0xff) <= 32) {
					driver->speed = effect & 0xff; /*  0`32:Xs[hݒ */
				} else {
					driver->tempo = effect & 0xff; /* 33`255:e|ݒ  */
				}
				channel->effect = 0; /* GtFNg */
				break;
			/*{{ΉGtFNg*/
			//case 0x000: /* Arpeggio */
			//case 0x300: /* Tone Portamento */
			//case 0x400: /* Vibrato */
			//case 0x700: /* Tremolo */
			//case 0x800: /* Set Panning Position */
			/**/#ifdef WIN32
			/**/default:
			/**/	fprintf(stderr, "IGN-EFF: %03x\n", effect);
			/**/	break;
			/**/#endif /*WIN32*/
			/*}}ΉGtFNg*/
			case 0xe00: /* Extended Effects */
				switch(effect & 0xf0) {
				/*---------- ɊւgGtFNg ----------*/
				case 0x10: /* Fine Slide Up */
					channel->period -= effect & 0xf;
					if(channel->period < 0) channel->period = 0;
					channel->effect = 0; /* GtFNg */
					break;
				case 0x20: /* Fine Slide Down */
					channel->period += effect & 0xf;
					if(channel->period > 0xfff) channel->period = 0xfff;
					channel->effect = 0; /* GtFNg */
					break;
				/*---------- ʂɊւgGtFNg ----------*/
				case 0xa0: /* Fine Volume Slide Up */
					channel->volume += effect & 0xf;
					if(channel->volume > 64) channel->volume = 64;
					channel->effect = 0; /* GtFNg */
					break;
				case 0xb0: /* Fine Volume Slide Down */
					channel->volume -= effect & 0xf;
					if(channel->volume < 0) channel->volume = 0;
					channel->effect = 0; /* GtFNg */
					break;
				/*{{ΉgGtFNg*/
				//case 0x00: /* Set Filter */
				//case 0x30: /* Glissando Control */
				//case 0x40: /* Set Vibrato Waveform */
				//case 0x50: /* Set Fine Tune */
				//case 0x60: /* Set/Jump to Loop */
				//case 0x70: /* Set Tremolo Waveform */
				//case 0x80: /* NOT USED */
				//case 0x90: /* Retrig Note */
				//case 0xc0: /* Note Cut */
				//case 0xd0: /* Note Delay */
				//case 0xe0: /* Pattern Delay */
				//case 0xf0: /* Invert Loop */
				/**/#ifdef WIN32
				/**/default:
				/**/	fprintf(stderr, "IGN-EFF: %03x\n", effect);
				/**/	break;
				/**/#endif /*WIN32*/
				/*}}ΉgGtFNg*/
				}
				break;
			}
		}
	}

	return 0;
}

int
mod_mix(MODDRIVER* driver, short wbuff[MODBUFLEN])
{
	MODHEADER* header = driver->header;
	int i, chno, period, length, repofs, replen, volume, offset, step;
	short* dst;
	char* smpdat;
	MODSAMPLE* sample;
	MODCHANNEL* channel;

	/* ܂~LVOobt@NA܂B */
	//memset(wbuff, 0, sizeof wbuff); Ȃ悤ӁI
	memset(wbuff, 0, sizeof(short) * MODBUFLEN);

	/* ̊e`lɂ... */
	for(chno = 0, channel = driver->channel; chno < 4; chno++, channel++) {
		if(!(period = channel->period)) continue;

		/* TvȂǂoĂ܂B */
		sample = &header->sample[channel->smpno];
		smpdat = driver->smpdat[channel->smpno];
		length = SWAPH(sample->length) * 2 << 8; /* 24.8bit */
		repofs = SWAPH(sample->repofs) * 2 << 8; /* 24.8bit */
		replen = SWAPH(sample->replen) * 2 << 8; /* 24.8bit */
		if(replen <= 1 * 2 << 8) replen = 0; /* j̗R(H)replen=1[vȂƂ */
		volume = channel->volume;
		offset = channel->offset;

		/* sIhlTvItZbg߂܂B
		 * * 萔̗RF
		 *	AmigaPAL{NbN(?) = 7093789.2[Hz]  񕪎ăTEhHɋH
		 *	P/ECẼTEho͎g =   16000  [Hz]
		 * * TvItZbgF
		 *	Đ[g    = 7093789.2 / (period * 2)
		 *	[24.8bit] = (Đ[g / 16000) * 256
		 *	              = ((7093789.2 / (period * 2)) / 16000) * 256
		 *	              = (((7093789.2 / 2) / period) / 16000) * 256
		 *	              = ((7093789.2 / (2 * 16000)) / period) * 256
		 *	              = ((7093789.2 * 256) / (2 * 16000)) / period
		 *	              = 56750.3136 / period
		 */
		step = 56750 / period;

		for(i = 0, dst = wbuff; i < MODBUFLEN; i++, dst++) {
LOOP:
			/* TvItZbgTvf[^ɃNsO܂B */
			if(!replen) {
				/* [vȂF
				 * 0length܂ōĐāA~܂B
				 */
				if(offset >= length) {
					channel->period = 0; /* ~ */
					goto NO_LOOP;
				}
			} else {
				/* [vF
				 * 0(repofs+replen),repofs(repofs+replen),...
				 * (repofs+replen)`length̋Ԃ͍Đ܂B
				 */
				if(offset >= repofs + replen) {
					offset -= replen;
					goto LOOP;
				}
			}

			/* ~LVOobt@ɃTvl~{[Z܂B */
			*dst += smpdat[offset >> 8] * volume;

			/* TvItZbgi߂܂B */
			offset += step;
		}
NO_LOOP:
		/* TvItZbg߂܂B */
		channel->offset = offset;
	}

	/* * 4`lÚA傤Ǖt16rbg̐UɈv܂B
	 *	}128(őTvl) ~ 64(ő{[) ~ 4(`l)  }32768
	 *   ʑ̕Kv͂܂񂪁A2{(1bitVtg)܂łȂ瑝ĂłB
	 *   xƂ̌ˍŁAD݂ɂāAǂB
	 * * VtgϐɂĎsɕύXł悤ɂ̂́A߂łB
	 *   S1C33 CPU ̃Vtg߂1߂8rbg܂łVtgłȂ̂ŁA
	 *   VtgϐɂƁAxslaɂȂāA8(!)ɓWJĂ܂܂B
	 */
	for(i = 0, dst = wbuff; i < MODBUFLEN; i++, dst++) {
		volume = *dst << 1/**/;
		if(volume < -32767) {
			volume = -32767;
		} else if(volume > 32767) {
			volume = 32767;
		}
		*dst = volume;
	}

	return 0;
}

